## menhir 20151112.dfsg

=== Makefile ===
# This is the main Makefile that is shipped as part of the source package.

# Keep in mind that the hierarchy that is shipped is not identical to the
# hierarchy within the git repository. Some sub-directories are not shipped.
# The documentation (manual.pdf, menhir.1) is pre-built and stored at the root.

# This Makefile can also be used directly in the repository. In that case,
# the documentation and demos are not installed.

# The hierarchy that is shipped includes:
#   demos
#   menhir.1
#   manual.pdf
#   src
#   Makefile (this one)

# ----------------------------------------------------------------------------

# The following variables must/can be configured.

ifndef PREFIX
  $(error Please define PREFIX)
endif

ifndef TARGET
  TARGET := native
endif

# ----------------------------------------------------------------------------

# By default, we attempt to use ocamlfind (if present in the PATH), but it
# is possible to prevent that externally by setting USE_OCAMLFIND to false.

ifndef USE_OCAMLFIND
  USE_OCAMLFIND = ocamlfind ocamlc -v >/dev/null 2>&1
endif

# ----------------------------------------------------------------------------
# Installation paths.
# These may be overridden from outside; e.g., our opam package description
# provides its own values of docdir, libdir, and mandir.

bindir          := $(PREFIX)/bin
docdir		:= $(PREFIX)/share/doc/menhir
libdir	        := $(PREFIX)/share/menhir
mandir          := $(PREFIX)/share/man/man1
MANS            := menhir.1
DOCS            := manual.pdf demos
MLYLIB          := src/standard.mly

# ----------------------------------------------------------------------------

# A few settings differ on Windows versus Unix.

# If the compiler is MSVC, then the name of the executable file ends in .exe,
# and object file names end in .obj instead of .o.

ifneq (,$(shell ocamlc -config | grep -E "ccomp_type: msvc"))
  MENHIREXE    := menhir.exe
  OBJ          := obj
# LIBSUFFIX    := lib
else
  MENHIREXE    := menhir
  OBJ          := o
# LIBSUFFIX    := a
endif

# The path $(installation_libdir), which is recorded in src/installation.ml (see
# below), must sometimes be translated using cygpath.

# This one is tricky. To summarize, if I understood correctly, we can assume
# that Cygwin always exists when Menhir is compiled and installed (because
# executing a Makefile, like this one, requires Cygwin), but we cannot assume
# that Menhir will be executed under Cygwin. If the OCaml compiler is
# configured to produce a Cygwin executable, then, yes, Cygwin is there at
# execution time, so path translation is not necessary (and should not be
# performed). On the other hand, if the OCaml compiler is configured to
# produce a native Windows executable, then Cygwin is not there at execution
# time and path translation is required. In summary, path translation must be
# performed if "os_type" is "Win32" or "Win64", and must not be performed if
# "os_type" is "Cygwin" or "Unix".

ifneq (,$(shell ocamlc -config | grep -E "os_type: (Win32|Win64)"))
installation_libdir := $(shell cygpath -m $(libdir))
else
installation_libdir := $(libdir)
endif

# -------------------------------------------------------------------------

# The names of the modules in MenhirLib are obtained by reading the
# non-comment lines in menhirLib.mlpack.

MENHIRLIB_MODULES := $(shell grep -ve "^[ \t\n\r]*\#" src/menhirLib.mlpack)

# ----------------------------------------------------------------------------

# The directory where things are built.

BUILDDIR := src/_stage2

# ----------------------------------------------------------------------------

# Compilation.

.PHONY: all install uninstall

all:
# Installation time settings are recorded within src/installation.ml.
# This file is recreated every time so as to avoid becoming stale.
	@ rm -f src/installation.ml
	@ echo "let libdir = \"$(installation_libdir)\"" > src/installation.ml
	@ if $(USE_OCAMLFIND) ; then \
	  echo "let ocamlfind = true" >> src/installation.ml ; \
	else \
	  echo "let ocamlfind = false" >> src/installation.ml ; \
	fi
# Compile the library modules and the Menhir executable.
	@ $(MAKE) -C src library bootstrap
# The source file menhirLib.ml is created by concatenating all of the source
# files that make up MenhirLib. This file is not needed to compile Menhir or
# MenhirLib. It is installed at the same time as MenhirLib and is copied by
# Menhir when the user requests a self-contained parser (one that is not
# dependent on MenhirLib).
	@ echo "Creating menhirLib.ml"
	@ rm -f $(BUILDDIR)/menhirLib.ml
	@ for m in $(MENHIRLIB_MODULES) ; do \
	  echo "module $$m = struct" >> $(BUILDDIR)/menhirLib.ml ; \
	  cat src/$$m.ml >> $(BUILDDIR)/menhirLib.ml ; \
	  echo "end" >> $(BUILDDIR)/menhirLib.ml ; \
	done
# The source file menhirLib.mli is created in the same way. If a module
# does not have an .mli file, then we assume that its .ml file contains
# type (and module type) definitions only, so we copy it instead of the
# (non-existent) .mli file.
	@ echo "Creating menhirLib.mli"
	@ rm -f $(BUILDDIR)/menhirLib.mli
	@ for m in $(MENHIRLIB_MODULES) ; do \
	  echo "module $$m : sig" >> $(BUILDDIR)/menhirLib.mli ; \
	  if [ -f src/$$m.mli ] ; then \
	    cat src/$$m.mli >> $(BUILDDIR)/menhirLib.mli ; \
	  else \
	    cat src/$$m.ml >> $(BUILDDIR)/menhirLib.mli ; \
	  fi ; \
	  echo "end" >> $(BUILDDIR)/menhirLib.mli ; \
	done

# -------------------------------------------------------------------------

# The files that should be installed as part of menhirLib.

MENHIRLIB       := menhirLib.mli menhirLib.ml menhirLib.cmi menhirLib.cmo
ifneq ($(TARGET),byte)
MENHIRLIB       := $(MENHIRLIB) menhirLib.cmx menhirLib.$(OBJ)
endif

# ----------------------------------------------------------------------------
# Installation.

install:
# Install the executable.
	mkdir -p $(bindir)
	install $(BUILDDIR)/menhir.$(TARGET) $(bindir)/$(MENHIREXE)
# Install the library.
	mkdir -p $(libdir)
	install -m 644 $(MLYLIB) $(libdir)
	@if $(USE_OCAMLFIND) ; then \
	  echo Installing MenhirLib via ocamlfind. ; \
	  ocamlfind install menhirLib src/META $(patsubst %,$(BUILDDIR)/%,$(MENHIRLIB)) ; \
	else \
	  echo Installing MenhirLib manually. ; \
	  install -m 644 $(patsubst %,$(BUILDDIR)/%,$(MENHIRLIB)) $(libdir) ; \
	fi
# Install the documentation, if it has been built.
	if [ -f manual.pdf ] ; then \
	  mkdir -p $(docdir) ; \
	  mkdir -p $(mandir) ; \
	  cp -r $(DOCS) $(docdir) ; \
	  cp -r $(MANS) $(mandir) ; \
	fi

uninstall:
	rm -rf $(bindir)/$(MENHIREXE)
	rm -rf $(libdir)
	@if $(USE_OCAMLFIND) ; then \
	  echo Un-installing MenhirLib via ocamlfind. ; \
	  ocamlfind remove menhirLib ; \
	fi
	rm -rf $(docdir)
	rm -rf $(mandir)/$(MANS)

=== demos/Makefile ===
DEMOS := calc calc-two calc-param calc-incremental calc-inspection

.PHONY: all clean

all:
	@for i in $(DEMOS) ; do \
	  $(MAKE) -C $$i ; \
	done

clean:
	/bin/rm -f *~ .*~
	@for i in $(DEMOS) ; do \
	  $(MAKE) -C $$i clean ; \
	done

=== src/Makefile ===
.PHONY: everyday library bootstrap stage1 stage2 stage3 clean

# ----------------------------------------------------------------------------
# Choose a target.

ifndef TARGET
  TARGET := native
endif

# ----------------------------------------------------------------------------
# Define the files that form the library.

ifeq ($(TARGET),byte)
  LIBFILES := menhirLib.cmo
else
  LIBFILES := menhirLib.cmo menhirLib.cmx
endif

# ----------------------------------------------------------------------------
# Ocamlbuild tool and settings.

OCAMLBUILD := ocamlbuild -classic-display -j 0 -cflags "-safe-string -bin-annot"

# ----------------------------------------------------------------------------
# For everyday development.
# Typing "make" will perform just stage 1. This is enough to ensure that
# the source code is correct.

everyday: installation.ml stage1

# ----------------------------------------------------------------------------
# Building MenhirLib.

library:
	$(OCAMLBUILD) $(LIBFILES)

# ----------------------------------------------------------------------------
# Building Menhir from scratch (a.k.a. bootstrapping).

bootstrap: .versioncheck stage1 stage2 stage3

# ----------------------------------------------------------------------------
# Checking the version of the OCaml compiler.

.versioncheck:
	@ echo Checking that Objective Caml is recent enough...
	@$(OCAMLBUILD) -build-dir _stage1 checkOCamlVersion.byte
	@ _stage1/checkOCamlVersion.byte --verbose --gt "4.02"
	@ touch $@

# ----------------------------------------------------------------------------
# Stage 1.
# Build Menhir using ocamlyacc.

stage1:
	@$(OCAMLBUILD) -build-dir _stage1 menhir.$(TARGET)

# ----------------------------------------------------------------------------
# Stage 2.
# Build Menhir using Menhir (from stage 1).

# Do not use . to refer to the current directory, because ocamlbuild
# descends into another directory when executing commands.
# Do not use $(shell pwd) either, because this assumes we are running
# on a Unix platform, and can fail on Windows.
# So, use .., which works fine if ocamlbuild has effectively descended
# into a subdirectory.
SRC   := ..

FLAGS := -v -lg 1 -la 1 -lc 1 --table --infer --stdlib $(SRC) --strict --fixed-exception --canonical

stage2:
	@$(OCAMLBUILD) -build-dir _stage2 -tag fancy_parser \
	  -use-menhir -menhir "$(SRC)/_stage1/menhir.$(TARGET) $(FLAGS)" \
	  menhir.$(TARGET)

# ----------------------------------------------------------------------------
# Stage 3 (optional).
# Re-generate Menhir's parser using Menhir (from stage 2) and check that it
# is identical to the stage 2 parser.
stage3:
	@$(OCAMLBUILD) -build-dir _stage3 -tag fancy_parser \
	  -use-menhir -menhir "$(SRC)/_stage2/menhir.$(TARGET) $(FLAGS)" \
	  parser.ml parser.mli
	@for i in parser.ml parser.mli ; do \
	  if ! diff _stage2/$$i _stage3/$$i 2>&1 >/dev/null ; then \
	    echo "Bootstrap FAILED: $$i did not reach a fixed point."; exit 1 ; \
	  fi ; \
	done; \
	echo "Bootstrap successful."

# ----------------------------------------------------------------------------
# Cleaning up.

clean::
	rm -rf .versioncheck _build _stage1 _stage2 _stage3

=== demos/calc-incremental/Makefile ===
.PHONY: all clean test

# Find Menhir.
ifndef MENHIR
  MENHIR := $(shell ../find-menhir.sh)
endif

# We use the table back-end, and link against menhirLib.
# We assume that menhirLib has been installed in such a
# way that ocamlfind knows about it.

MENHIRFLAGS     := --table
# -- infer is automatically added by ocamlbuild.

OCAMLBUILD      := ocamlbuild -use-ocamlfind -use-menhir -menhir "$(MENHIR) $(MENHIRFLAGS)" -package menhirLib

MAIN            := calc

all:
	$(OCAMLBUILD) $(MAIN).native

clean:
	rm -f *~ .*~
	$(OCAMLBUILD) -clean

test: all
	@echo "The following command should print 42:"
	echo "(1 + 2 * 10) * 2" | ./$(MAIN).native

=== demos/calc-inspection/Makefile ===
.PHONY: all clean test

# Find Menhir.
ifndef MENHIR
  MENHIR := $(shell ../find-menhir.sh)
endif

# We use the table back-end, and link against menhirLib.
# We assume that menhirLib has been installed in such a
# way that ocamlfind knows about it.

MENHIRFLAGS     := --table --inspection -v -la 2
# -- infer is automatically added by ocamlbuild.

OCAMLBUILD      := ocamlbuild -use-ocamlfind -use-menhir -menhir "$(MENHIR) $(MENHIRFLAGS)" -package menhirLib

MAIN            := calc

all:
	$(OCAMLBUILD) $(MAIN).native

clean:
	rm -f *~ .*~
	$(OCAMLBUILD) -clean

test: all
	@echo "The following command should print 42:"
	echo "(1 + 2 * 10) * 2" | ./$(MAIN).native
	@echo "The following command should print an error message:"
	echo "(1 + 2 * 10) * )" | ./$(MAIN).native
	@echo "The following command should print an error message:"
	echo "(1 + 2 * 10))" | ./$(MAIN).native

=== demos/calc-two/Makefile ===
.PHONY: all clean test

# Find Menhir.
ifndef MENHIR
  MENHIR := $(shell ../find-menhir.sh)
endif

MENHIRFLAGS     := --infer

OCAMLBUILD      := ocamlbuild -use-ocamlfind -use-menhir -menhir "$(MENHIR) $(MENHIRFLAGS)"

MAIN            := calc

all:
	$(OCAMLBUILD) $(MAIN).native

clean:
	rm -f *~ .*~
	$(OCAMLBUILD) -clean

test: all
	@echo "The following command should print 42:"
	echo "(1 + 2 * 10) * 2" | ./$(MAIN).native --algebraic
	@echo "The following command should print 42:"
	echo " 1 2 10 * + 2 *" | ./$(MAIN).native --reverse

=== debian/changelog ===
menhir (20151112.dfsg-1) unstable; urgency=medium

  * New upstream release.
    - Refresh patches
    - Add 0002-Pass-byte-plugin-to-ocamlbuild-when-TARGET-byte.patch
      to avoid FTBFS on bytecode architectures.
  * Use Upstream's Makefile to install files

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 17 Jan 2016 22:06:28 +0100

menhir (20141215.dfsg-1~exp1) experimental; urgency=medium

  * New upstream release
    - Requires OCaml >= 4.02~.

 -- Mehdi Dogguy <mehdi@debian.org>  Mon, 20 Jul 2015 00:00:56 +0000

=== debian/control ===
Source: menhir
Section: devel
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
  Samuel Mimram <smimram@debian.org>,
  Mehdi Dogguy <mehdi@debian.org>
Build-Depends:
  debhelper (>= 7.0.50),
  ocaml-nox (>= 4.02~),
  ocaml-findlib,
  dh-ocaml (>= 0.9)
Standards-Version: 3.9.2
Homepage: http://gallium.inria.fr/~fpottier/menhir/
Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/menhir.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/menhir.git

Package: menhir
Architecture: any
Depends:
  ${ocaml:Depends},
  ${shlibs:Depends},
  ${misc:Depends}
Description: Parser generator for OCaml
 Menhir is a LR(1) parser generator for OCaml. It is mostly compatible
 with the standard ocamlyacc and has the following enhancements:
  * it accepts LR(1) grammars,
  * it offers parameterized nonterminal symbols as well as a library of
    standard definitions,
  * it explains conflicts in terms of the grammar,
  * it allows grammar specifications to be split over multiple files and
    parametrized by OCaml modules,
  * it produces reentrant parsers.

Package: libmenhir-ocaml-dev
Section: ocaml
Architecture: any
Depends:
  ${ocaml:Depends},
  ${shlibs:Depends},
  ${misc:Depends}
Provides:
  ${ocaml:Provides}
Description: Menhir library for OCaml
 This package contains the Menhir library for OCaml. It gives access to,
 among others, the following modules:
  * InfiniteArray: implements infinite arrays, that is, arrays
    that grow transparently upon demand.
  * RowDisplacement: compresses a two-dimensional table, where some
    values are considered insignificant, via row displacement.
  * Engine: LR parsing engine.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DH_VERBOSE=1

include /usr/share/ocaml/ocamlvars.mk

DESTDIR := $(CURDIR)/debian/menhir
export OCAMLFIND_DESTDIR := $(CURDIR)/debian/tmp/$(OCAML_STDLIB_DIR)
BEST := native
ifneq ($(OCAML_BEST),opt)
BEST = byte
endif


override_dh_auto_build:
	$(MAKE) TARGET=$(BEST) PREFIX=/usr

override_dh_auto_clean:
	$(MAKE) -C src/ clean PREFIX=$(DESTDIR)/usr

override_dh_auto_install:
	mkdir -p $(OCAMLFIND_DESTDIR)
	$(MAKE) TARGET=$(BEST) PREFIX=$(DESTDIR)/usr install

override_dh_auto_test:

%:
	dh --with ocaml $@

## menhir 20160808+dfsg

=== Makefile ===
--- 
+++ 
@@ -30,6 +30,11 @@
 
 # By default, we attempt to use ocamlfind (if present in the PATH), but it
 # is possible to prevent that externally by setting USE_OCAMLFIND to false.
+
+# USE_OCAMLFIND is used only at build time (i.e., by "make all"). At
+# (un)installation time, instead, we query menhir using --suggest-ocamlfind.
+# This should protect us against people who pass USE_OCAMLFIND at build time
+# and forget to pass it at (un)installation time.
 
 ifndef USE_OCAMLFIND
   USE_OCAMLFIND = ocamlfind ocamlc -v >/dev/null 2>&1
@@ -164,27 +169,26 @@
 # Install the library.
 	mkdir -p $(libdir)
 	install -m 644 $(MLYLIB) $(libdir)
-	@if $(USE_OCAMLFIND) ; then \
-	  echo Installing MenhirLib via ocamlfind. ; \
+	@if `$(BUILDDIR)/menhir.$(TARGET) --suggest-ocamlfind` ; then \
+	  echo 'Installing MenhirLib via ocamlfind.' ; \
 	  ocamlfind install menhirLib src/META $(patsubst %,$(BUILDDIR)/%,$(MENHIRLIB)) ; \
 	else \
-	  echo Installing MenhirLib manually. ; \
+	  echo 'Installing MenhirLib manually.' ; \
 	  install -m 644 $(patsubst %,$(BUILDDIR)/%,$(MENHIRLIB)) $(libdir) ; \
 	fi
 # Install the documentation, if it has been built.
 	if [ -f manual.pdf ] ; then \
-	  mkdir -p $(docdir) ; \
-	  mkdir -p $(mandir) ; \
-	  cp -r $(DOCS) $(docdir) ; \
+	  mkdir -p $(docdir) $(mandir) && \
+	  cp -r $(DOCS) $(docdir) && \
 	  cp -r $(MANS) $(mandir) ; \
 	fi
 
 uninstall:
+	@if `$(bindir)/$(MENHIREXE) --suggest-ocamlfind` ; then \
+	  echo 'Un-installing MenhirLib via ocamlfind.' ; \
+	  ocamlfind remove menhirLib ; \
+	fi
 	rm -rf $(bindir)/$(MENHIREXE)
 	rm -rf $(libdir)
-	@if $(USE_OCAMLFIND) ; then \
-	  echo Un-installing MenhirLib via ocamlfind. ; \
-	  ocamlfind remove menhirLib ; \
-	fi
 	rm -rf $(docdir)
 	rm -rf $(mandir)/$(MANS)

=== src/Makefile ===
--- 
+++ 
@@ -43,9 +43,8 @@
 # Checking the version of the OCaml compiler.
 
 .versioncheck:
-	@ echo Checking that Objective Caml is recent enough...
-	@$(OCAMLBUILD) -build-dir _stage1 checkOCamlVersion.byte
-	@ _stage1/checkOCamlVersion.byte --verbose --gt "4.02"
+	@ echo Checking that OCaml is recent enough...
+	@ ocaml checkOCamlVersion.ml --verbose --gt "4.02"
 	@ touch $@
 
 # ----------------------------------------------------------------------------

=== debian/changelog ===
menhir (20160808+dfsg-1) unstable; urgency=medium

  * Team upload
  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Tue, 16 Aug 2016 10:06:20 +0200

menhir (20160526.dfsg-1) unstable; urgency=medium

  * Team upload
  * New upstream release
  * Update Vcs-*
  * Switch debian/copyright to format 1.0
  * Bump Standards-Version to 3.9.8
  * Bump debhelper compat to 9

 -- Stéphane Glondu <glondu@debian.org>  Sat, 06 Aug 2016 10:55:33 +0200

=== debian/control ===
--- 
+++ 
@@ -6,14 +6,14 @@
   Samuel Mimram <smimram@debian.org>,
   Mehdi Dogguy <mehdi@debian.org>
 Build-Depends:
-  debhelper (>= 7.0.50),
+  debhelper (>= 9),
   ocaml-nox (>= 4.02~),
   ocaml-findlib,
   dh-ocaml (>= 0.9)
-Standards-Version: 3.9.2
+Standards-Version: 3.9.8
 Homepage: http://gallium.inria.fr/~fpottier/menhir/
-Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/menhir.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/menhir.git
+Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/menhir.git
+Vcs-Browser: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/menhir.git
 
 Package: menhir
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -26,4 +26,4 @@
 override_dh_auto_test:
 
 %:
-	dh --with ocaml $@
+	dh $@ --with ocaml

## menhir 20170607.dfsg

=== debian/changelog ===
menhir (20170607.dfsg-1) unstable; urgency=medium

  * New upstream:
    - refresh patch 0002-Pass-byte-plugin-to-ocamlbuild-when-TARGET-byte
  * Delete obsolete debian/README.source
  * debian/purify_tarball:
    - simplify (drop useless CURDIR)
    - generate tarball with version "+dfsg" instead of ".dfsg"
  * Add myself as uploader
  * Add as-installed package test

 -- Ralf Treinen <treinen@debian.org>  Mon, 19 Jun 2017 22:11:44 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,8 @@
 Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders:
   Samuel Mimram <smimram@debian.org>,
-  Mehdi Dogguy <mehdi@debian.org>
+  Mehdi Dogguy <mehdi@debian.org>,
+  Ralf Treinen <treinen@debian.org>
 Build-Depends:
   debhelper (>= 9),
   ocaml-nox (>= 4.02~),

=== debian/tests/control ===
Tests: calcdemo
Depends: ocaml-nox, libfindlib-ocaml

## menhir 20170712

=== Makefile ===
--- 
+++ 
@@ -100,9 +100,12 @@
 
 # ----------------------------------------------------------------------------
 
-# The directory where things are built.
-
+# The directories where things are built.
+
+# For Menhir and MenhirLib.
 BUILDDIR := src/_stage2
+# For MenhirSdk.
+SDKDIR   := src/_sdk
 
 # ----------------------------------------------------------------------------
 
@@ -120,8 +123,10 @@
 	else \
 	  echo "let ocamlfind = false" >> src/installation.ml ; \
 	fi
-# Compile the library modules and the Menhir executable.
-	@ $(MAKE) -C src library bootstrap
+# Compile the Menhir executable.
+# This causes MenhirLib to be compiled, too, as it is used inside Menhir.
+# Compile MenhirSdk.
+	@ $(MAKE) -C src bootstrap sdk
 # The source file menhirLib.ml is created by concatenating all of the source
 # files that make up MenhirLib. This file is not needed to compile Menhir or
 # MenhirLib. It is installed at the same time as MenhirLib and is copied by
@@ -159,6 +164,15 @@
 MENHIRLIB       := $(MENHIRLIB) menhirLib.cmx menhirLib.$(OBJ)
 endif
 
+# -------------------------------------------------------------------------
+
+# The files that should be installed as part of menhirSdk.
+
+MENHIRSDK       := menhirSdk.cmi menhirSdk.cmo
+ifneq ($(TARGET),byte)
+MENHIRSDK       := $(MENHIRSDK) menhirSdk.cmx menhirSdk.$(OBJ)
+endif
+
 # ----------------------------------------------------------------------------
 # Installation.
 
@@ -166,15 +180,21 @@
 # Install the executable.
 	mkdir -p $(bindir)
 	install $(BUILDDIR)/menhir.$(TARGET) $(bindir)/$(MENHIREXE)
-# Install the library.
+# Install Menhir's standard library.
 	mkdir -p $(libdir)
 	install -m 644 $(MLYLIB) $(libdir)
-	@if `$(BUILDDIR)/menhir.$(TARGET) --suggest-ocamlfind` ; then \
-	  echo 'Installing MenhirLib via ocamlfind.' ; \
-	  ocamlfind install menhirLib src/META $(patsubst %,$(BUILDDIR)/%,$(MENHIRLIB)) ; \
+# Install MenhirLib and MenhirSdk.
+	@if `$(BUILDDIR)/menhir.$(TARGET) --suggest-ocamlfind | tr -d '\r'` ; then \
+	  echo 'Installing MenhirLib and MenhirSdk via ocamlfind.' ; \
+	  cp -f src/menhirLib.META META ; \
+	  ocamlfind install menhirLib META $(patsubst %,$(BUILDDIR)/%,$(MENHIRLIB)) ; \
+	  cp -f src/menhirSdk.META META ; \
+	  ocamlfind install menhirSdk META $(patsubst %,$(SDKDIR)/%,$(MENHIRSDK)) ; \
+	  rm -f META ; \
 	else \
-	  echo 'Installing MenhirLib manually.' ; \
+	  echo 'Installing MenhirLib and MenhirSdk manually.' ; \
 	  install -m 644 $(patsubst %,$(BUILDDIR)/%,$(MENHIRLIB)) $(libdir) ; \
+	  install -m 644 $(patsubst %,$(SDKDIR)/%,$(MENHIRSDK)) $(libdir) ; \
 	fi
 # Install the documentation, if it has been built.
 	if [ -f manual.pdf ] ; then \
@@ -185,8 +205,9 @@
 
 uninstall:
 	@if `$(bindir)/$(MENHIREXE) --suggest-ocamlfind` ; then \
-	  echo 'Un-installing MenhirLib via ocamlfind.' ; \
+	  echo 'Un-installing MenhirLib and MenhirSdk via ocamlfind.' ; \
 	  ocamlfind remove menhirLib ; \
+	  ocamlfind remove menhirSdk ; \
 	fi
 	rm -rf $(bindir)/$(MENHIREXE)
 	rm -rf $(libdir)

=== src/Makefile ===
.PHONY: everyday bootstrap stage1 stage2 stage3 sdk clean

# ----------------------------------------------------------------------------
# Choose a target.

ifndef TARGET
  TARGET := native
endif

# ----------------------------------------------------------------------------
# Ocamlbuild tool and settings.

OCAMLBUILD := ocamlbuild -classic-display -j 0

# ----------------------------------------------------------------------------
# For everyday development.
# Typing "make" will perform just stage 1. This is enough to ensure that
# the source code is correct.

everyday: installation.ml stage1

# ----------------------------------------------------------------------------
# Building Menhir from scratch (a.k.a. bootstrapping).

bootstrap: .versioncheck
	@ $(MAKE) stage1
	@ $(MAKE) stage2
	@ $(MAKE) stage3

# ----------------------------------------------------------------------------
# Checking the version of the OCaml compiler.

# We explicitly build checkOCamlVersion as an OCaml binary program,
# instead of running it as a script, because that would require
# #loading str.cma, which is not supported on (some versions of?)
# Windows.

.versioncheck:
	@ echo Checking that OCaml is recent enough...
	@ rm -rf _versioncheck
	@ $(OCAMLBUILD) -build-dir _versioncheck checkOCamlVersion.byte
	@ _versioncheck/checkOCamlVersion.byte --verbose --gt "4.02"
	@ rm -rf _versioncheck
	@ touch $@

# ----------------------------------------------------------------------------
# Stage 1.
# Build Menhir using ocamlyacc.

stage1:
	@ $(OCAMLBUILD) -build-dir _stage1 menhir.$(TARGET)

# ----------------------------------------------------------------------------
# Stage 2.
# Build Menhir using Menhir (from stage 1).

# Do not use . to refer to the current directory, because ocamlbuild
# descends into another directory when executing commands.
# Do not use $(shell pwd) either, because this assumes we are running
# on a Unix platform, and can fail on Windows.
# So, use .., which works fine if ocamlbuild has effectively descended
# into a subdirectory.
SRC   := ..

FLAGS := -v -lg 1 -la 1 -lc 1 --table --infer --stdlib $(SRC) --strict --fixed-exception --canonical

stage2:
	@ $(OCAMLBUILD) -build-dir _stage2 -tag fancy_parser \
	    -use-menhir -menhir "$(SRC)/_stage1/menhir.$(TARGET) $(FLAGS)" \
	    menhir.$(TARGET)

# ----------------------------------------------------------------------------
# Stage 3 (optional).
# Re-generate Menhir's parser using Menhir (from stage 2) and check that it
# is identical to the stage 2 parser.
stage3:
	@ $(OCAMLBUILD) -build-dir _stage3 -tag fancy_parser \
	    -use-menhir -menhir "$(SRC)/_stage2/menhir.$(TARGET) $(FLAGS)" \
	    parser.ml parser.mli
	@ for i in parser.ml parser.mli ; do \
	    if ! diff _stage2/$$i _stage3/$$i 2>&1 >/dev/null ; then \
	      echo "Bootstrap FAILED: $$i did not reach a fixed point."; exit 1 ; \
	    fi ; \
	  done; \
	  echo "Bootstrap successful."

# -------------------------------------------------------------------------

# The ocamlbuild targets that should be used to build menhirSdk.

MENHIRSDK       := menhirSdk.cmo
ifneq ($(TARGET),byte)
MENHIRSDK       := $(MENHIRSDK) menhirSdk.cmx
endif

# ----------------------------------------------------------------------------
# Building menhirSdk.

sdk:
	@ $(OCAMLBUILD) \
	    -build-dir _sdk \
	    -tag sdk \
	    $(MENHIRSDK)

# ----------------------------------------------------------------------------
# Cleaning up.

clean::
	rm -rf .versioncheck _stage1 _stage2 _stage3 _sdk

=== debian/changelog ===
menhir (20170712-1) unstable; urgency=medium

  * New upstream release, now including the sources of the manual.
  * New binary package menhir-doc, containing the manual in pdf
    (closes: #484497).
    - add debian/menhir-doc.docs, debian/menhir-doc.doc-base.
    - examples go now into the menhir-doc package.
    - menhir suggests menhir-doc.
  * Since we now have the sources of the manual:
    - drop debian/purify-tarball which is no longer needed.
    - drop upstream filtering from debian/gbp.conf
  * debian/rules:
    - let upstream's makefile install into debian/tmp, then install stuff
      into package directories with dh_*.
    - use dh_missing --fail-missing
  * Added build-dependency on ocamlbuild.
  * Dropped debian/menhir.manpages, debian/menhir.dirs
  * debian/tests/control: add dependency on @
  * Changed section to ocaml
  * Minor improvements of package descriptions.
  * Updated debian/copyright:
    - update header (upstream name and contact)
    - complete file list of library files
    - the files not being part of the library are under GPLv2 now
    - bump copyright years

 -- Ralf Treinen <treinen@debian.org>  Sat, 22 Jul 2017 19:58:29 +0200

menhir (20170607.dfsg-3) unstable; urgency=medium

  * as-installed tests: add dependency ocaml-findlib 

 -- Ralf Treinen <treinen@debian.org>  Sun, 02 Jul 2017 13:32:18 +0200

menhir (20170607.dfsg-2) unstable; urgency=medium

  * Standards-Version 4.0.0
    - https form of the copyright-format URL
  * libmenhir-ocaml-dev: install everything that upstream installs in
    /usr/lib/ocaml
  * DH compat level 10

 -- Ralf Treinen <treinen@debian.org>  Tue, 20 Jun 2017 08:24:06 +0200

=== debian/control ===
Source: menhir
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
  Samuel Mimram <smimram@debian.org>,
  Mehdi Dogguy <mehdi@debian.org>,
  Ralf Treinen <treinen@debian.org>
Build-Depends:
  debhelper (>= 10),
  ocaml-nox (>= 4.02~),
  ocamlbuild,
  ocaml-findlib,
  dh-ocaml (>= 0.9)
Standards-Version: 4.0.0
Homepage: http://gallium.inria.fr/~fpottier/menhir/
Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/menhir.git
Vcs-Browser: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/menhir.git

Package: menhir
Architecture: any
Depends:
  ${ocaml:Depends},
  ${shlibs:Depends},
  ${misc:Depends}
Suggests: menhir-doc
Description: Parser generator for OCaml
 Menhir is a LR(1) parser generator for the OCaml programming language.
 It is mostly compatible with the ocamlyacc parser generator provided with
 the OCaml system, and has the following enhancements over ocamlyacc:
  * it accepts LR(1) grammars,
  * it offers parameterized nonterminal symbols as well as a library of
    standard definitions,
  * it explains conflicts in terms of the grammar,
  * it allows grammar specifications to be split over multiple files and
    parametrized by OCaml modules,
  * it produces reentrant parsers.

Package: libmenhir-ocaml-dev
Architecture: any
Depends:
  ${ocaml:Depends},
  ${shlibs:Depends},
  ${misc:Depends}
Provides:
  ${ocaml:Provides}
Description: Menhir library for OCaml
 Menhir is a LR(1) parser generator for the OCaml programming language.
 It is mostly compatible with the ocamlyacc parser generator provided with
 OCaml, and has a number of enhancements over ocamlyacc.
 .
 This package contains the Menhir library for the OCaml programming language.
 It gives access to, among others, the following modules:
  * InfiniteArray: implements infinite arrays, that is, arrays
    that grow transparently upon demand.
  * RowDisplacement: compresses a two-dimensional table, where some
    values are considered insignificant, via row displacement.
  * Engine: LR parsing engine.

Package: menhir-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Documentation of the Menhir parser generator for OCaml
 Menhir is a LR(1) parser generator for the OCaml programming language.
 It is mostly compatible with the ocamlyacc parser generator provided with
 OCaml, and has a number of enhancements over ocamlyacc.
 .
 This package contains the Menhir manual as a pdf file, and the collection
 of Menhir examples.

=== debian/tests/control ===
Tests: calcdemo
Depends: @, ocaml-nox, ocaml-findlib

## menhir 20171206

=== debian/changelog ===
menhir (20171206-1) unstable; urgency=medium

  * New upstream version.
  * Standards-version 4.1.2 (no change)
  * Drop debian/source/local-options

 -- Ralf Treinen <treinen@debian.org>  Wed, 13 Dec 2017 21:31:45 +0100

menhir (20171013-1) unstable; urgency=medium

  * New upstream version.
    - drop patch Remove-some-invalid-characters which has been applied upstream
    - drop patch Pass-byte-plugin-to-ocamlbuild-when-TARGET-byte which has
      been applied upstream
  * Standards-Version 4.1.1 (no change)
  * d/tests/control: add dependency ocamlbuild

 -- Ralf Treinen <treinen@debian.org>  Thu, 23 Nov 2017 08:42:12 +0100

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
   ocamlbuild,
   ocaml-findlib,
   dh-ocaml (>= 0.9)
-Standards-Version: 4.0.0
+Standards-Version: 4.1.2
 Homepage: http://gallium.inria.fr/~fpottier/menhir/
 Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/menhir.git
 Vcs-Browser: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/menhir.git

## menhir 20171222

=== Makefile ===
--- 
+++ 
@@ -57,17 +57,23 @@
 
 # A few settings differ on Windows versus Unix.
 
-# If the compiler is MSVC, then the name of the executable file ends in .exe,
-# and object file names end in .obj instead of .o.
+# If the compiler is MSVC, then object file names end in .obj instead of .o.
 
 ifneq (,$(shell ocamlc -config | grep -E "ccomp_type: msvc"))
-  MENHIREXE    := menhir.exe
   OBJ          := obj
 # LIBSUFFIX    := lib
 else
-  MENHIREXE    := menhir
   OBJ          := o
 # LIBSUFFIX    := a
+endif
+
+# If we are under Windows (regardless of whether we are using MSVC or mingw)
+# then the name of the executable file ends in .exe.
+
+ifeq ($(OS),Windows_NT)
+  MENHIREXE    := menhir.exe
+else
+  MENHIREXE    := menhir
 endif
 
 # The path $(installation_libdir), which is recorded in src/installation.ml (see

=== demos/Makefile ===
# The following demos require menhirLib:
#   calc-incremental
#   calc-inspection
# The following demos require menhirSdk:
#   generate-printers

DEMOS := \
  calc \
  calc-two \
  calc-param \
  calc-incremental \
  calc-inspection \
  generate-printers \

.PHONY: all clean

all clean::
	@for i in $(DEMOS) ; do \
	  $(MAKE) -C $$i $@ ; \
	done

clean::
	/bin/rm -f *~ .*~

=== doc/Makefile ===
.PHONY: all loop clean

export TEXINPUTS=.:

all: main.pdf

%.pdf: %.tex $(wildcard *.tex) $(wildcard *.bib) $(wildcard *.sty) $(wildcard *.mly)
	pdflatex $*
	bibtex $*
	pdflatex $*
	pdflatex $*

loop:
	latexmk -pdf -pvc main

clean:
	rm -f `cat .gitignore`

=== src/Makefile ===
--- 
+++ 
@@ -11,6 +11,9 @@
 # Ocamlbuild tool and settings.
 
 OCAMLBUILD := ocamlbuild -classic-display -j 0
+ifeq ($(TARGET),byte)
+  OCAMLBUILD := $(OCAMLBUILD) -byte-plugin
+endif
 
 # ----------------------------------------------------------------------------
 # For everyday development.
@@ -22,26 +25,10 @@
 # ----------------------------------------------------------------------------
 # Building Menhir from scratch (a.k.a. bootstrapping).
 
-bootstrap: .versioncheck
+bootstrap:
 	@ $(MAKE) stage1
 	@ $(MAKE) stage2
 	@ $(MAKE) stage3
-
-# ----------------------------------------------------------------------------
-# Checking the version of the OCaml compiler.
-
-# We explicitly build checkOCamlVersion as an OCaml binary program,
-# instead of running it as a script, because that would require
-# #loading str.cma, which is not supported on (some versions of?)
-# Windows.
-
-.versioncheck:
-	@ echo Checking that OCaml is recent enough...
-	@ rm -rf _versioncheck
-	@ $(OCAMLBUILD) -build-dir _versioncheck checkOCamlVersion.byte
-	@ _versioncheck/checkOCamlVersion.byte --verbose --gt "4.02"
-	@ rm -rf _versioncheck
-	@ touch $@
 
 # ----------------------------------------------------------------------------
 # Stage 1.
@@ -106,4 +93,4 @@
 # Cleaning up.
 
 clean::
-	rm -rf .versioncheck _stage1 _stage2 _stage3 _sdk
+	rm -rf _stage1 _stage2 _stage3 _sdk

=== demos/calc/Makefile ===
.PHONY: all clean test

# Find Menhir.
ifndef MENHIR
  MENHIR := $(shell ../find-menhir.sh)
endif

MENHIRFLAGS     := --infer

OCAMLBUILD      := ocamlbuild -use-ocamlfind -use-menhir -menhir "$(MENHIR) $(MENHIRFLAGS)"

MAIN            := calc

all:
	$(OCAMLBUILD) $(MAIN).native

clean:
	rm -f *~ .*~
	$(OCAMLBUILD) -clean

test: all
	@echo "The following command should print 42:"
	echo "(1 + 2 * 10) * 2" | ./$(MAIN).native

=== debian/changelog ===
menhir (20171222-1) unstable; urgency=medium

  * New upstream version.
  * Standards-version 4.1.3 (no change)

 -- Ralf Treinen <treinen@debian.org>  Tue, 02 Jan 2018 19:23:01 +0100

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
   ocamlbuild,
   ocaml-findlib,
   dh-ocaml (>= 0.9)
-Standards-Version: 4.1.2
+Standards-Version: 4.1.3
 Homepage: http://gallium.inria.fr/~fpottier/menhir/
 Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/menhir.git
 Vcs-Browser: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/menhir.git

=== debian/rules ===
--- 
+++ 
@@ -5,8 +5,8 @@
 
 include /usr/share/ocaml/ocamlvars.mk
 
-DESTDIR := $(CURDIR)/debian/menhir
-export OCAMLFIND_DESTDIR := $(CURDIR)/debian/tmp/$(OCAML_STDLIB_DIR)
+DESTDIR := $(CURDIR)/debian/tmp
+export OCAMLFIND_DESTDIR := $(DESTDIR)/$(OCAML_STDLIB_DIR)
 BEST := native
 ifneq ($(OCAML_BEST),opt)
 BEST = byte
@@ -23,6 +23,9 @@
 	mkdir -p $(OCAMLFIND_DESTDIR)
 	$(MAKE) TARGET=$(BEST) PREFIX=$(DESTDIR)/usr install
 
+override_dh_missing:
+	dh_missing --fail-missing
+
 override_dh_auto_test:
 
 %:

=== debian/tests/control ===
Tests: calcdemo
Depends: @, ocaml-nox, ocaml-findlib, ocamlbuild

=== debian/watch ===
version=3

opts=dversionmangle=s/\+dfsg// \
        http://pauillac.inria.fr/~fpottier/menhir/menhir-(.*)\.tar\.gz

## menhir 20180530

=== Makefile ===
--- 
+++ 
@@ -11,6 +11,7 @@
 #   demos
 #   menhir.1
 #   manual.pdf
+#   manual.html
 #   src
 #   Makefile (this one)
 
@@ -50,7 +51,7 @@
 libdir	        := $(PREFIX)/share/menhir
 mandir          := $(PREFIX)/share/man/man1
 MANS            := menhir.1
-DOCS            := manual.pdf demos
+DOCS            := manual.pdf manual.html demos
 MLYLIB          := src/standard.mly
 
 # ----------------------------------------------------------------------------

=== demos/Makefile ===
--- 
+++ 
@@ -1,8 +1,12 @@
 # The following demos require menhirLib:
 #   calc-incremental
 #   calc-inspection
+
 # The following demos require menhirSdk:
 #   generate-printers
+
+# The demos whose name ends in -dune require dune (a.k.a. jbuilder)
+# and assume that Menhir is installed.
 
 DEMOS := \
   calc \
@@ -11,6 +15,9 @@
   calc-incremental \
   calc-inspection \
   generate-printers \
+#  calc-dune \             # this demo causes [make check] to fail
+#  calc-incremental-dune \ # this demo causes [make check] to fail
+#  calc-inspection-dune \  # this demo requires new Dune, not yet released
 
 .PHONY: all clean

=== doc/Makefile ===
.PHONY: all loop clean

export TEXINPUTS=.:

DEPS = $(wildcard *.tex) $(wildcard *.bib) $(wildcard *.sty) $(wildcard *.mly)

SED := $(shell if hash gsed 2>/dev/null ; then echo gsed ; else echo sed ; fi)

all: manual.pdf manual.html

%.pdf: %.tex $(DEPS)
	pdflatex $*
	bibtex $*
	pdflatex $*
	pdflatex $*

manual.html: manual.tex $(DEPS) $(wildcard *.hva)
	hevea -fix manual.tex
#
# Hevea interprets 'tabbing' environment in a way
# that creates spacing errors in the rendered output
# of "textual version of derivation trees": it
# asks for (padding:0px;) while the TeX rendering
# inserts spacing between columns. Change this
# to {padding:1px;}
	$(SED) -i -e "s/cellpadding0/cellpadding1/" manual.html
#
# Note: hevea generates images manual00{1,2,3}.png for the tikz pictures
# present in the manual.

loop:
	latexmk -pdf -pvc main

clean:
	rm -f `cat .gitignore`

=== demos/calc-dune/Makefile ===
.PHONY: all clean test

DUNE       := jbuilder
EXECUTABLE := calc.exe

all:
	@ if command -v $(DUNE) > /dev/null ; then \
	  $(DUNE) build $(EXECUTABLE) ; \
	else \
	  echo "Error: $(DUNE) is required." ; \
	fi

clean:
	rm -rf `cat .gitignore`
	rm -f *~

test: all
	@echo "The following command should print 42:"
	echo "(1 + 2 * 10) * 2" | ./_build/default/$(EXECUTABLE)

=== demos/calc-inspection-dune/Makefile ===
.PHONY: all clean test

DUNE       := jbuilder
EXECUTABLE := calc.exe

all:
	@ if command -v $(DUNE) > /dev/null ; then \
	  $(DUNE) build $(EXECUTABLE) ; \
	else \
	  echo "Error: $(DUNE) is required." ; \
	fi

clean:
	rm -rf `cat .gitignore`
	rm -f *~

test: all
	@echo "The following command should print 42:"
	echo "(1 + 2 * 10) * 2" | ./_build/default/$(EXECUTABLE)
	@echo "The following command should print an error message:"
	echo "(1 + 2 * 10) * )" | ./_build/default/$(EXECUTABLE)
	@echo "The following command should print an error message:"
	echo "(1 + 2 * 10))" | ./_build/default/$(EXECUTABLE)

## menhir 20181113

=== Makefile ===
--- 
+++ 
@@ -50,32 +50,24 @@
 docdir		:= $(PREFIX)/share/doc/menhir
 libdir	        := $(PREFIX)/share/menhir
 mandir          := $(PREFIX)/share/man/man1
-MANS            := menhir.1
-DOCS            := manual.pdf manual.html demos
+MANS            := doc/menhir.1
+DOCS            := doc/manual.pdf doc/manual.html doc/manual*.png demos
 MLYLIB          := src/standard.mly
 
 # ----------------------------------------------------------------------------
 
-# A few settings differ on Windows versus Unix.
-
-# If the compiler is MSVC, then object file names end in .obj instead of .o.
-
-ifneq (,$(shell ocamlc -config | grep -E "ccomp_type: msvc"))
-  OBJ          := obj
-# LIBSUFFIX    := lib
-else
-  OBJ          := o
-# LIBSUFFIX    := a
-endif
-
-# If we are under Windows (regardless of whether we are using MSVC or mingw)
-# then the name of the executable file ends in .exe.
-
-ifeq ($(OS),Windows_NT)
-  MENHIREXE    := menhir.exe
-else
-  MENHIREXE    := menhir
-endif
+# The following incantations should work on both Windows and Unix,
+# and allow us to abstract away the differences.
+
+# The extension of object files.
+OBJ := $(shell ocamlc -config | sed -n '/^ext_obj:/p' | sed 's/ext_obj: //')
+# The extension of executable files.
+# Note: the field "ext_exe" seems to have appeared in OCaml 4.05.
+# With earlier versions of OCaml, this incantation defines $(EXE)
+# as the empty string, which could be a problem under Windows.
+EXE := $(shell ocamlc -config | sed -n '/^ext_exe:/p' | sed 's/ext_exe: //')
+# The OS type.
+OS_TYPE := $(shell ocamlc -config | sed -n '/^os_type:/p' | sed 's/os_type: //')
 
 # The path $(installation_libdir), which is recorded in src/installation.ml (see
 # below), must sometimes be translated using cygpath.
@@ -92,10 +84,10 @@
 # performed if "os_type" is "Win32" or "Win64", and must not be performed if
 # "os_type" is "Cygwin" or "Unix".
 
-ifneq (,$(shell ocamlc -config | grep -E "os_type: (Win32|Win64)"))
-installation_libdir := $(shell cygpath -m $(libdir))
+ifeq ($(OS_TYPE),$(filter $(OS_TYPE),Win32 Win64))
+  installation_libdir := $(shell cygpath -m $(libdir) || echo $(libdir))
 else
-installation_libdir := $(libdir)
+  installation_libdir := $(libdir)
 endif
 
 # -------------------------------------------------------------------------
@@ -168,7 +160,7 @@
 
 MENHIRLIB       := menhirLib.mli menhirLib.ml menhirLib.cmi menhirLib.cmo
 ifneq ($(TARGET),byte)
-MENHIRLIB       := $(MENHIRLIB) menhirLib.cmx menhirLib.$(OBJ)
+MENHIRLIB       := $(MENHIRLIB) menhirLib.cmx menhirLib.cmxs menhirLib$(OBJ)
 endif
 
 # -------------------------------------------------------------------------
@@ -177,7 +169,7 @@
 
 MENHIRSDK       := menhirSdk.cmi menhirSdk.cmo
 ifneq ($(TARGET),byte)
-MENHIRSDK       := $(MENHIRSDK) menhirSdk.cmx menhirSdk.$(OBJ)
+MENHIRSDK       := $(MENHIRSDK) menhirSdk.cmx menhirSdk.cmxs menhirSdk$(OBJ)
 endif
 
 # ----------------------------------------------------------------------------
@@ -186,7 +178,7 @@
 install:
 # Install the executable.
 	mkdir -p $(bindir)
-	install $(BUILDDIR)/menhir.$(TARGET) $(bindir)/$(MENHIREXE)
+	install $(BUILDDIR)/menhir.$(TARGET) $(bindir)/menhir$(EXE)
 # Install Menhir's standard library.
 	mkdir -p $(libdir)
 	install -m 644 $(MLYLIB) $(libdir)
@@ -203,20 +195,21 @@
 	  install -m 644 $(patsubst %,$(BUILDDIR)/%,$(MENHIRLIB)) $(libdir) ; \
 	  install -m 644 $(patsubst %,$(SDKDIR)/%,$(MENHIRSDK)) $(libdir) ; \
 	fi
-# Install the documentation, if it has been built.
-	if [ -f manual.pdf ] ; then \
-	  mkdir -p $(docdir) $(mandir) && \
-	  cp -r $(DOCS) $(docdir) && \
+# Install the documentation. (If building from the repository, the documentation
+# may be absent.)
+	if [ -f doc/manual.pdf ] ; then \
+	  mkdir -p $(docdir) $(mandir) ; \
+	  cp -r $(DOCS) $(docdir) ; \
 	  cp -r $(MANS) $(mandir) ; \
 	fi
 
 uninstall:
-	@if `$(bindir)/$(MENHIREXE) --suggest-ocamlfind` ; then \
+	@if `$(bindir)/menhir$(EXE) --suggest-ocamlfind` ; then \
 	  echo 'Un-installing MenhirLib and MenhirSdk via ocamlfind.' ; \
 	  ocamlfind remove menhirLib ; \
 	  ocamlfind remove menhirSdk ; \
 	fi
-	rm -rf $(bindir)/$(MENHIREXE)
+	rm -rf $(bindir)/menhir$(EXE)
 	rm -rf $(libdir)
 	rm -rf $(docdir)
 	rm -rf $(mandir)/$(MANS)

=== demos/calc-inspection-dune/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 .PHONY: all clean test
 
-DUNE       := jbuilder
+DUNE       := dune
 EXECUTABLE := calc.exe
 
 all:

=== debian/changelog ===
menhir (20181113-1) unstable; urgency=medium

  * new upstream version
  * d/watch: point to inria gitlab
  * d/menhir-doc.docs: also install png pictures of the manual
  * d/rules: remove .gitignore files in examples
  * Standards-Version 4.2.1 (no change)

 -- Ralf Treinen <treinen@debian.org>  Wed, 14 Nov 2018 22:14:32 +0100

menhir (20180530-2) unstable; urgency=medium

  * menhir-doc: Breaks/Replaces menhir (<< 20170712-1) since examples
    had been moved from menhir to menhir-doc (closes: #903455)
  * Standards-version 4.1.5 (no change).

 -- Ralf Treinen <treinen@debian.org>  Thu, 19 Jul 2018 22:19:24 +0200

menhir (20180530-1) unstable; urgency=medium

  * New upstream version. 
  * Install manual.html into menhir-doc package.
  * Add entry for html manual in doc-base file
  * Update Vcs-* fields to salsa.
  * Standards-Version 4.1.4 (no change).
  * Debhelper compat level 11.
    - menhir-doc.doc-base: manual now installed in /usr/share/doc/menhr

 -- Ralf Treinen <treinen@debian.org>  Mon, 18 Jun 2018 20:39:09 +0200

=== debian/control ===
--- 
+++ 
@@ -7,15 +7,15 @@
   Mehdi Dogguy <mehdi@debian.org>,
   Ralf Treinen <treinen@debian.org>
 Build-Depends:
-  debhelper (>= 10),
+  debhelper (>= 11),
   ocaml-nox (>= 4.02~),
   ocamlbuild,
   ocaml-findlib,
   dh-ocaml (>= 0.9)
-Standards-Version: 4.1.3
+Standards-Version: 4.2.1
 Homepage: http://gallium.inria.fr/~fpottier/menhir/
-Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/menhir.git
-Vcs-Browser: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/menhir.git
+Vcs-Browser: https://salsa.debian.org/ocaml-team/menhir
+Vcs-Git: https://salsa.debian.org/ocaml-team/menhir.git
 
 Package: menhir
 Architecture: any
@@ -59,6 +59,8 @@
 
 Package: menhir-doc
 Section: doc
+Replaces: menhir (<< 20170712-1)
+Breaks:  menhir (<< 20170712-1)
 Architecture: all
 Depends: ${misc:Depends}
 Description: Documentation of the Menhir parser generator for OCaml

=== debian/rules ===
--- 
+++ 
@@ -23,6 +23,15 @@
 	mkdir -p $(OCAMLFIND_DESTDIR)
 	$(MAKE) TARGET=$(BEST) PREFIX=$(DESTDIR)/usr install
 
+override_dh_installexamples:
+	dh_installexamples
+	if [ -d debian/menhir-doc/usr/share/doc/menhir/examples ]; \
+	then \
+	  find debian/menhir-doc/usr/share/doc/menhir/examples \
+	    -name .gitignore -delete ; \
+	fi
+
+
 override_dh_missing:
 	dh_missing --fail-missing
